/*
Oddsock - StreamRipper32 (Win32 front end to streamripper library)
Copyright (C) 2000  Oddsock

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#define VERSION "Version 2.6"

#include "ResizableDialog.h"
#include "stdafx.h"
#include "SRipper.h"
#include "SRipperDlg.h"
#include "TrayNot.h"
extern "C" {
#include <rip_manager.h>
#include <util.h>
extern int writeFileFlag;

}
#include <afxtempl.h>
#include <afxmt.h>
#include <process.h>
#include "frontend.h"
#include "FolderDialog.h"
#include "MirrorSelect.h"

#include "PatternDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>
extern "C" {
#include <libxml/HTMLparser.h>
#include <libxml/HTMLtree.h>
}


typedef struct tag_parms {
	char *ip;
	int	port;
	char *dest;
} parms;

//FILE	*pGenM3u = 0;

bool	bRipping = false;

int		lastByteUpdate = 0;

bool	gIsRipping = FALSE;
CSRipperDlg *m_CurrentDialog;

extern int GetHTTP(LPCSTR , int , LPCSTR , char *, char *);

CArray<CString, CString>	StationPatterns;
CArray<CString, CString>	SongPatterns;

CArray<CString, CString>	Descs;
CArray<CString, CString>	Bitrates;
CArray<CString, CString>	TuneIns;
CArray<CString, CString>	Metaflags;

CArray<CString, CString>	sortedDescs;
CArray<CString, CString>	sortedBitrates;
CArray<CString, CString>	sortedTuneIns;
CArray<CString, CString>			sortedMetaflags;

CPatternDialog		patternDialog;
VOID CALLBACK TimerProc(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime);

RIP_MANAGER_INFO 	m_curinfo;
bool	StopTheRipping = false;

CString URLize(CString input)
{
	CString tempString;

	tempString = input;

	tempString.Replace("%", "%25");
	tempString.Replace(";", "%3B");
	tempString.Replace("/", "%2F");
	tempString.Replace("?", "%3F");
	tempString.Replace(":", "%3A");
	tempString.Replace("@", "%40");
	tempString.Replace("&", "%26");
	tempString.Replace("=", "%3D");
	tempString.Replace("+", "%2B");
	tempString.Replace(" ", "%20");
	tempString.Replace("\"", "%5C");
	tempString.Replace("#", "%23");
	
	tempString.Replace("<", "%3C");
	tempString.Replace(">", "%3E");
	tempString.Replace("!", "%21");
	tempString.Replace("*", "%2A");
	tempString.Replace("'", "%27");
	tempString.Replace("(", "%28");
	tempString.Replace(")", "%29");
	tempString.Replace(",", "%2C");

	return tempString;
}

int gCount = 0;
bool bConnecting = false;

void rip_callback(int message, void *data)
{
	RIP_MANAGER_INFO *info;
	ERROR_INFO *err;
	char	filesize_str[128] = "";
	switch(message)
	{
		case RM_UPDATE:
			bConnecting = false;
			info = (RIP_MANAGER_INFO*)data;
			memcpy(&m_curinfo, info, sizeof(RIP_MANAGER_INFO));
			format_byte_size(filesize_str, m_curinfo.filesize);

			m_CurrentDialog->SetDlgItemText(IDC_STREAMNAME, m_curinfo.streamname);
			m_CurrentDialog->m_StreamName = m_curinfo.streamname;
			switch(m_curinfo.status)
			{
				case RM_STATUS_BUFFERING:
					m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Buffering");
					break;

				case RM_STATUS_RIPPING:
//					if (m_CurrentDialog->m_bHidden) {
					if (m_CurrentDialog->m_pTray) {
						memset(m_CurrentDialog->m_pTray->m_tnd.szTip, '\000', sizeof(m_CurrentDialog->m_pTray->m_tnd.szTip));
						strncpy(m_CurrentDialog->m_pTray->m_tnd.szTip, m_curinfo.filename, sizeof(m_CurrentDialog->m_pTray->m_tnd.szTip)-1);
						if (!(m_CurrentDialog->m_OptionDialog.m_IconAnim)) {
							if (m_CurrentDialog->m_iconSwap) {
								m_CurrentDialog->m_iconSwap = 0;
								m_CurrentDialog->m_pTray->SetState(0);
							}
							else {
								m_CurrentDialog->m_iconSwap = 1;
								m_CurrentDialog->m_pTray->SetState(1);
							}
						}

					}
					m_CurrentDialog->m_SongTitle = m_curinfo.filename;
					m_CurrentDialog->SetDlgItemText(IDC_SONGTITLE, m_curinfo.filename);
				//	lastByteUpdate = 0;
					if (m_CurrentDialog->m_PatternEnable) {
						if (writeFileFlag) {
							m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Ripping Matched Track");
						}
						else {
							m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Ripping Paused");
						}
					}
					else {
							m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Ripping Stream");
					}
					break;
				case RM_STATUS_RECONNECTING:
					m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Reconnecting");
					break;
			}
			
			m_CurrentDialog->m_Bytes = filesize_str;
			if (m_CurrentDialog->m_MaxBytes > 0) {

				m_CurrentDialog->m_MaxBytes = m_CurrentDialog->m_MaxBytes - (atol(filesize_str) - lastByteUpdate);
				lastByteUpdate = atol(filesize_str);
			}
			if (m_CurrentDialog->m_MaxBytes < 0) {
				m_CurrentDialog->m_MaxBytes = 0;
				if (!StopTheRipping) {
					StopTheRipping = 1;
				}
			}
			m_CurrentDialog->SetDlgItemText(IDC_BYTES, filesize_str);
			m_CurrentDialog->SetDlgItemInt(IDC_MAXBYTES, m_CurrentDialog->m_MaxBytes);
			break;
		case RM_ERROR:
			err = (ERROR_INFO*)data;
			MessageBox(NULL, err->error_str, "StreamRipper Error", MB_OK);
			bRipping = false;
			bConnecting = false;
			m_CurrentDialog->StopRipping();
			break;
		case RM_DONE:
			bConnecting = false;
			bRipping = false;
			break;
		case RM_NEW_TRACK:
			bool bNewTrack;
			bConnecting = false;
			m_CurrentDialog->CheckIncludedTrack((char *)data);
			bNewTrack = true;
			break;
		case RM_STARTED:
			bConnecting = false;
			m_CurrentDialog->m_ConnectRelay.EnableWindow(TRUE);
			break;
	}
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRipperDlg dialog

CSRipperDlg::CSRipperDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CSRipperDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSRipperDlg)
	m_Destination = _T("");
	m_SelectedBroadcast = _T("");
	m_GenreValue = _T("");
	m_SongTitle = _T("");
	m_MaxBytes = 0;
	m_StreamName = _T("");
	m_RelayPort = 0;
	m_Bytes = _T("");
	m_Status = _T("");
	m_URL = _T("");
	m_PatternEnable = FALSE;
	m_Version = _T("");
	m_SearchText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_iconSwap = 0;
	m_bHidden = false;
	m_Version = VERSION;
	m_pTray = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSRipperDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSRipperDlg)
	DDX_Control(pDX, IDC_PATTERNMATCH, m_PatternMatch);
	DDX_Control(pDX, IDC_URL, m_URLctrl);
	DDX_Control(pDX, IDC_RELAYPORT, m_RelayPortCtrl);
	DDX_Control(pDX, IDC_CONNECT_RELAY, m_ConnectRelay);
	DDX_Control(pDX, IDC_LIST_CTRL, m_cListCtrl);
	DDX_Control(pDX, IDC_MAXBYTES, m_MaxBytesCtl);
	DDX_Control(pDX, IDC_FOLDER, m_Folder);
	DDX_Control(pDX, IDOK, m_OKctrl);
	DDX_Control(pDX, IDC_DESTINATION, m_Destinationctrl);
	DDX_Control(pDX, IDC_STOPRIPPING, m_StopRipping);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	DDX_Control(pDX, IDC_RIPAWAY, m_Ripaway);
	DDX_Control(pDX, IDC_GENRE, m_Genre);
	DDX_Text(pDX, IDC_DESTINATION, m_Destination);
	DDX_CBString(pDX, IDC_GENRE, m_GenreValue);
	DDX_Text(pDX, IDC_SONGTITLE, m_SongTitle);
	DDX_Text(pDX, IDC_MAXBYTES, m_MaxBytes);
	DDX_Text(pDX, IDC_STREAMNAME, m_StreamName);
	DDX_Text(pDX, IDC_RELAYPORT, m_RelayPort);
	DDX_Text(pDX, IDC_BYTES, m_Bytes);
	DDX_Text(pDX, IDC_RIPPING, m_Status);
	DDX_Text(pDX, IDC_URL, m_URL);
	DDX_Check(pDX, IDC_PATTERN_ENABLE, m_PatternEnable);
	DDX_Text(pDX, IDC_STATIC3, m_Version);
	DDX_Text(pDX, IDC_SEARCHTEXT, m_SearchText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSRipperDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CSRipperDlg)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_RIPAWAY, OnRipaway)
	ON_CBN_EDITCHANGE(IDC_GENRE, OnEditchangeGenre)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_STOPRIPPING, OnStopripping)
	ON_EN_UPDATE(IDC_BYTES, OnUpdateBytes)
	ON_EN_UPDATE(IDC_SONGTITLE, OnUpdateSongtitle)
	ON_EN_UPDATE(IDC_DESTINATION, OnUpdateDestination)
	ON_BN_CLICKED(IDC_FOLDER, OnFolder)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_CTRL, OnDblclkListCtrl)
	ON_BN_CLICKED(IDC_CONNECT_RELAY, OnConnectRelay)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_CTRL, OnColumnclickListCtrl)
	ON_BN_CLICKED(IDC_ADDPATTERN, OnAddpattern)
	ON_BN_CLICKED(IDC_DELETEPATTERN, OnDeletepattern)
	ON_BN_CLICKED(IDC_PATTERN_ENABLE, OnPatternEnable)
	ON_MESSAGE(WM_TRAY_NOTIFY, OnTrayNotify)
	ON_COMMAND(ID_TRAY_RESTORE, OnTrayRestore)
	ON_BN_CLICKED(IDC_HIDE, OnHideapp)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)
	ON_BN_CLICKED(IDC_MOREOPTIONS, OnMoreoptions)
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SIR, OnSir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRipperDlg message handlers



BOOL CSRipperDlg::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	UpdateData(TRUE);

	m_Genre.AddString("TopTen");
	m_Genre.AddString("Classical");
	m_Genre.AddString("Comedy");
	m_Genre.AddString("Country");
	m_Genre.AddString("Techno");
	m_Genre.AddString("Dance");
	m_Genre.AddString("Funk");
	m_Genre.AddString("Jazz");
	m_Genre.AddString("Metal");
	m_Genre.AddString("Mixed");
	m_Genre.AddString("Pop");
	m_Genre.AddString("R&B");
	m_Genre.AddString("Rap");
	m_Genre.AddString("Rock");
	m_Genre.AddString("Talk");
	m_Genre.AddString("Various");
	m_Genre.AddString("80s");
	m_Genre.AddString("70s");


	UpdateData(TRUE);

	char	dest[1024] = "";
	char	tmpbuf[255] = "";
	char	strAppendStreamName[25] = "";
	char	strWinampBuffer[25] = "";

	GetPrivateProfileString("SRipper","OutputDir","",dest,sizeof(dest), "sripper.ini");
	memset(tmpbuf, '\000', sizeof(tmpbuf));
	GetPrivateProfileString("SRipper","lastURL", "", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	m_URL = tmpbuf;
	memset(tmpbuf, '\000', sizeof(tmpbuf));
	GetPrivateProfileString("SRipper","UserAgent", "StreamRipper32/1.0", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	m_OptionDialog.m_UserAgent = tmpbuf;
	memset(tmpbuf, '\000', sizeof(tmpbuf));
	GetPrivateProfileString("SRipper","relayPort", "10069", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	m_RelayPort = atoi(tmpbuf);

	GetPrivateProfileString("SRipper","addID3", "TRUE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_OptionDialog.m_AddId3 = TRUE;
	}
	else {
		m_OptionDialog.m_AddId3 = FALSE;
	}
	GetPrivateProfileString("SRipper","genM3U", "TRUE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_OptionDialog.m_CreateM3U = TRUE;
	}
	else {
		m_OptionDialog.m_CreateM3U = FALSE;
	}
	GetPrivateProfileString("SRipper","addSeqNumber", "FALSE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_OptionDialog.m_AddSeq = TRUE;
	}
	else {
		m_OptionDialog.m_AddSeq = FALSE;
	}
	GetPrivateProfileString("SRipper","Overwrite", "FALSE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_OptionDialog.m_Overwrite = TRUE;
	}
	else {
		m_OptionDialog.m_Overwrite = FALSE;
	}
	GetPrivateProfileString("SRipper","PatternEnable", "FALSE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_PatternEnable = TRUE;
	}
	else {
		m_PatternEnable = FALSE;
	}
	GetPrivateProfileString("SRipper","IconAnim", "FALSE", tmpbuf, sizeof(tmpbuf), "sripper.ini");
	if (!strcmp(tmpbuf, "TRUE")) {
		m_OptionDialog.m_IconAnim = TRUE;
	}
	else {
		m_OptionDialog.m_IconAnim = FALSE;
	}

	int loop = 1;
	char buf[25] = "";
	char stationPattern[255] = "";
	char songPattern[255] = "";

	int counter = 0;
	while (loop) {
		memset(buf, '\000', sizeof(buf));
		memset(stationPattern, '\000', sizeof(stationPattern));
		memset(songPattern, '\000', sizeof(songPattern));
		sprintf(buf, "StationPattern%d", counter);
		GetPrivateProfileString("SRipper",buf, "", stationPattern, sizeof(stationPattern), "sripper.ini");
		sprintf(buf, "SongPattern%d", counter);
		GetPrivateProfileString("SRipper",buf, "", songPattern, sizeof(songPattern), "sripper.ini");

		if ((strlen(stationPattern) == 0) && (strlen(songPattern) == 0)) {
			loop = 0;
		}
		else {
			if (!strcmp(stationPattern, "EndOfStations")) {
				loop = 0;
			}
			else {
				StationPatterns.Add(stationPattern);
				SongPatterns.Add(songPattern);
			}
		}
		counter++;
	}
	m_Destination = dest;

	m_StreamName = "StreamRipper 32";
	UpdateData(FALSE);
	m_CurrentDialog = this;

	m_ConnectRelay.EnableWindow(FALSE);

	CRect rect;
	m_cListCtrl.GetClientRect(&rect);

	int nColInterval = rect.Width()/10;
	m_cListCtrl.InsertColumn(0, _T("Description"), LVCFMT_LEFT, nColInterval*7+21);
	m_cListCtrl.InsertColumn(1, _T("Bitrate"), LVCFMT_LEFT, nColInterval+8);
	m_cListCtrl.InsertColumn(2, _T("Track Info"), LVCFMT_LEFT, /*rect.Width()-4* */nColInterval*7+15);

	m_PatternMatch.InsertColumn(0, _T("Stream Name"), LVCFMT_LEFT, nColInterval*7+21);
	m_PatternMatch.InsertColumn(1, _T("Pattern"), LVCFMT_LEFT, nColInterval+30);

	LVITEM lvi;

	m_PatternMatch.DeleteAllItems();
	for (int i = 0; i < StationPatterns.GetSize();i++) {
		lvi.mask =  LVIF_IMAGE | LVIF_TEXT;
		// strItem.Format(_T("Item %i"), i);
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = (LPTSTR)(LPCTSTR)(StationPatterns.GetAt(i));
		m_PatternMatch.InsertItem(&lvi);

		lvi.iSubItem = 1;
		lvi.pszText = (LPTSTR)(LPCTSTR)(SongPatterns.GetAt(i));
		m_PatternMatch.SetItem(&lvi);


	}
	
	m_cListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	AddAnchor(IDC_LIST_CTRL, TOP_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_PATTERNMATCH, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_STATIC1, TOP_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_STATIC4, TOP_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_STREAMNAME, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_SONGTITLE, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_STATIC5, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_STATIC3, BOTTOM_LEFT);
	AddAnchor(IDC_RIPPING, BOTTOM_LEFT);
	AddAnchor(IDC_SIR_STATIC, BOTTOM_LEFT);
	AddAnchor(IDC_SIR, BOTTOM_LEFT);

	EnableSaveRestore("StreamRipper32", "winposition");

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSRipperDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CResizableDialog::OnSysCommand(nID, lParam);
	}
}


HANDLE	ripThread = 0;
HANDLE	winampThread = 0;

extern "C" {
	extern char	gUserAgent[1024];
}
void CSRipperDlg::OnRipaway() 
{
	char	url[1024] = "";

	bConnecting = true;

	UpdateData(TRUE);

	SetTimer(0, 1, TimerProc);
	if (m_URL.Find("http://") == -1) {
		m_URL = "http://" + m_URL;
	}
	strcpy(url, LPCSTR(m_URL));
	SetDlgItemText(IDC_URL, url);

	m_StopRipping.EnableWindow(TRUE);
	m_Ripaway.EnableWindow(FALSE);
	m_Genre.EnableWindow(FALSE);
	m_Refresh.EnableWindow(FALSE);
	m_Destinationctrl.EnableWindow(FALSE);
	m_URLctrl.EnableWindow(FALSE);
	m_OKctrl.EnableWindow(FALSE);
	m_Folder.EnableWindow(FALSE);
	m_MaxBytesCtl.EnableWindow(FALSE);
	m_RelayPortCtrl.EnableWindow(FALSE);


	RIP_MANAGER_OPTIONS	m_opt;

	memset(&m_opt, '\000', sizeof(m_opt));

	if (m_RelayPort > 0) {
		m_opt.relay_port = m_RelayPort;
		m_opt.flags = OPT_MAKE_RELAY | OPT_AUTO_RECONNECT | OPT_SEPERATE_DIRS | OPT_SEARCH_PORTS;
	}
	else {
		m_opt.flags = OPT_AUTO_RECONNECT | OPT_SEPERATE_DIRS | OPT_SEARCH_PORTS;
	}
	if (m_OptionDialog.m_CreateM3U) {
		m_opt.flags |= OPT_WRITE_M3U;
	}

	m_opt.max_port = 18000;
//	m_opt.search_ports = TRUE;
//	m_opt.auto_reconnect = TRUE;		// tested ok
	strcpy(m_opt.output_directory, LPCSTR(m_Destination));	// tested ok
	m_opt.proxyurl[0] = (char)NULL;		// not tested
//	m_opt.seperate_dirs = TRUE;		// tested
	if (m_OptionDialog.m_Overwrite) {
		m_opt.flags |= OPT_OVER_WRITE_TRACKS;
	}
	if (m_OptionDialog.m_AddId3) {
		m_opt.flags |= OPT_ADD_ID3;
	}
	if (m_OptionDialog.m_AddSeq) {
		m_opt.flags |= OPT_COUNT_FILES;
	}

	strcpy(m_opt.useragent, m_OptionDialog.m_UserAgent);

	strncpy(m_opt.url, url, MAX_URL_LEN);

	int	ret = 0;
	SetDlgItemText(IDC_STREAMNAME, "");
	SetDlgItemText(IDC_SONGTITLE, "");
	SetDlgItemText(IDC_RIPPING, "Connecting");
	UpdateWindow();

	if ((ret = rip_manager_start(rip_callback, &m_opt)) != SR_SUCCESS)
	{
		char	msg[1024] = "";
		if (ret == SR_ERROR_LIVE365) {
			sprintf(msg, "Sorry, but StreamRipper32 does not support ripping Live365 streams");
		}
		else {
			sprintf(msg, "Couldn't connect to %s\n", m_opt.url);
		}
		MessageBox(msg, "Error", MB_OK);
		bRipping = false;
		OnStopripping();
		return;
	}
	bRipping = true;
}

void CSRipperDlg::OnEditchangeGenre() 
{
	// TODO: Add your control notification handler code here
	;
}

#if 0
void CSRipperDlg::OnDblclkBroadcasts() 
{
	// TODO: Add your control notification handler code here

	CString	ip;
	CString	tunein;
	CArray<CString, CString>	ClusterEntries;
	CArray<CString, CString>	ClusterEntryDescs;
	char	result[100000] = "";
	char	request[100000] = "";
	UpdateData(TRUE);
	ip = IPs.GetAt(m_Broadcasts.GetCurSel());
	tunein = TuneIns.GetAt(m_Broadcasts.GetCurSel());

	ClusterEntries.RemoveAll();
	ClusterEntryDescs.RemoveAll();
	if (ClusterFlags.GetAt(m_Broadcasts.GetCurSel())) {
		memset(result, '\000', sizeof(result));
		strcpy(request, "/sbin/shoutcast-playlist.pls");
		strcat(request, tunein);
		GetHTTP("yp.shoutcast.com", 80, request, "Host: yp.shoutcast.com\r\nAccept: */*", result);

		char *p1 = 0;
		p1 = strstr(result, "[playlist]");
		if (p1 == NULL) {
			MessageBox("Could not retrieve cluster information", "Error", MB_OK);
		}
		else {
			char	*p2;
			char	strnumentries[25] = "";
			int		numentries = 0;
			p2 = strstr(p1, "numberofentries=");
			if (p2 != NULL) {
				p2 = p2 + strlen("numberofentries=");
				char	*p3;
				p3 = strstr(p2, "\n");
				if (p3 != NULL) {
					memset(strnumentries, '\000', sizeof(strnumentries));
					strncpy(strnumentries, p2, p3-p2);
					numentries = atoi(strnumentries);
				}
				CMirrorSelect	mirrorDialog;

				for (int i=1;i<=numentries;i++) {
					char	*p4;
					char	*p5;
					char	Tag[25] = "";
					char	IP[35] = "";
					char	Desc[255] = "";
					memset(IP, '\000', sizeof(IP));
					memset(Desc, '\000', sizeof(Desc));
					sprintf(Tag, "File%d", i);
					p4 = strstr(p3, Tag);
					if (p4 != NULL) {
						p4 = p4 + strlen(Tag) + 1 + strlen("http://");
						p5 = strstr(p4, "\n");
						if (p5 != NULL) {
							strncpy(IP, p4, p5-p4);
						}
					}
					sprintf(Tag, "Title%d", i);
					p4 = strstr(p3, Tag);
					if (p4 != NULL) {
						p4 = p4 + strlen(Tag) + 1;
						p5 = strstr(p4, "\n");
						if (p5 != NULL) {
							strncpy(Desc, p4, p5-p4);
						}
					}
					mirrorDialog.m_ClusterEntries.Add(IP);
					mirrorDialog.m_ClusterEntryDescs.Add(Desc);
				}


				mirrorDialog.m_Selected = -1;
				mirrorDialog.DoModal();
			
				if (mirrorDialog.m_Selected != -1) {
					ip = mirrorDialog.m_ClusterEntries.GetAt(mirrorDialog.m_Selected);
				}
	
			}
		}


	}

	char	*p1;
	char	theip[255] = "";
	char	theport[25] = "";
	p1 = strchr(ip, ':');
	memset(theip, '\000', sizeof(theip));
	memset(theport, '\000', sizeof(theport));

	if (p1 != NULL) {
		strncpy(theip, ip, p1 - ip);
		strcpy(theport, p1 + 1);
		CString m_IP = theip;
		int m_Port = atoi(theport);
		char	bleh[255] = "";
		sprintf(bleh, "http://%s:%d", m_IP, m_Port);
		m_URL = bleh;
		UpdateData(FALSE);
	}

}
#endif

struct MemoryStruct {
        char *memory;
        size_t size;
};

MemoryStruct	pgResult;

size_t
URLCallback(void *ptr, size_t size, size_t nmemb, void *data)
{
        register int realsize = size * nmemb;
        struct MemoryStruct *mem = (struct MemoryStruct *)data;

		if (mem->memory) {
			char *p1 = (char *)1;
			while (p1) {
				p1 = strchr(mem->memory, '&');
				if (p1) {
					*p1 = ' ';
					p1++;
				}
			}
		}
        mem->memory = (char *)realloc(mem->memory, mem->size + realsize + 1);
        if (mem->memory) {
                memcpy(&(mem->memory[mem->size]), ptr, realsize);
                mem->size += realsize;
                mem->memory[mem->size] = 0;
        }
        return realsize;
}

int descNext = 0;
int playingNext = 0;
int tdCounts = 0;
int	tdStart = 0;
int skip = 0;
int gMetaflag = 0;

extern "C"                              
void                                            
HTMLerrorDebug(void *ctx ATTRIBUTE_UNUSED, const char *msg, ...)
{                                       
        ;                               
}   
static void
HTMLcharacters(void *ctx ATTRIBUTE_UNUSED, const xmlChar *ch, int len)
{

	char	value[1024] = "";
	memset(value, '\000', sizeof(value));
	strncpy(value, (char *)ch, len);
	if (descNext) {
		Descs.Add(value);
		descNext = 0;
		tdCounts = 1;
	}
	if (tdCounts == 1) {
		if (playingNext) {
			Metaflags.Add(value);
			gMetaflag = 1;
			playingNext = 0;
		}
		if (!strcmp(value, "Now Playing:")) {
			playingNext = 1;
		}
	}
	if (tdCounts == 3) {
		if (skip == 0) {
			// Listeners
//			MessageBox(NULL, (char *)value, NULL, MB_OK);
			skip = 1;
		}
		else {
			skip = 0;
		}

	}
	if (tdCounts == 5) {
		if (skip == 0) {
			Bitrates.Add(value);
			skip = 1;
		}
		else {
			skip = 0;
		}
	}
	if (tdCounts == 6) {
		tdCounts = 0;
		tdStart = 0;
		playingNext = 0;
		if (!gMetaflag) {
			Metaflags.Add("");
		}
		gMetaflag = 0;
	}

}

void
HTMLstartElement(void *ctx, const xmlChar *fullname, const xmlChar **atts)
{
        const xmlChar *att;
        const xmlChar *value;
        
       
        if (!stricmp((char *)fullname, "a")) {
                int i = 0;
                if (atts != NULL) {
                        i = 0;
						int loop = 1;
						while (loop) {
							att = atts[i++];
							value = atts[i++];
							if (att) {
								if (!stricmp((char *)att, (char *)"id" )) {
									if (!strcmp((char *)value, "listlinks")) {
										descNext = 1;
									}
								}
								if (!stricmp((char *)att, (char *)"href" )) {
									if (strstr((char *)value, "shoutcast-playlist.pls")) {
										CString tempString = value;
										tempString.Replace(" file=filename", "&file=filename");
										TuneIns.Add("http://www.shoutcast.com/" + tempString);
//										MessageBox(NULL, (char *)value, NULL, MB_OK);
										tdStart = 1;
									}
								}
							}
							else {
								loop = 0;
							}
						}
                }
        }
        if (!stricmp((char *)fullname, "td")) {
			if (tdStart) {
				tdCounts++;
			}
        }

}

#define GENRE_SEARCH 1
#define TEXT_SEARCH 2

void CSRipperDlg::DoSearch(int type) 
{
	char	request[255] = "";
	LVITEM lvi;
	CString strItem;
    htmlSAXHandler      SAXHandlerStruct; 
    htmlSAXHandlerPtr   SAXHandler = &SAXHandlerStruct;
    htmlDocPtr doc;


	BeginWaitCursor();

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
		CString output;
		if (type == GENRE_SEARCH) {
			output = URLize(m_GenreValue);
			sprintf(request, "http://www.shoutcast.com/directory/?sgenre=%s", output);
		}
		if (type == TEXT_SEARCH) {
			output = URLize(m_SearchText);
			sprintf(request, "http://www.shoutcast.com/directory/?s=%s&numresult=50", output);
		}

		if (output == "") {
			MessageBox("You must supply a search value", NULL, MB_OK);
			return;
		}
        CURL *curl = NULL;


        if (pgResult.memory) {
                free(pgResult.memory);
        }
        pgResult.memory = NULL;
        pgResult.size = 0;
        curl = curl_easy_init();

        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, URLCallback);
        curl_easy_setopt(curl, CURLOPT_FILE, (void *)&(pgResult));
		curl_easy_setopt(curl, CURLOPT_URL, request);

		int res = curl_easy_perform(curl);

        memset(SAXHandler,0,sizeof(htmlSAXHandler));
      SAXHandlerStruct.error = (errorSAXFunc)&HTMLerrorDebug;
      SAXHandlerStruct.startElement = &HTMLstartElement;
      SAXHandlerStruct.characters = &HTMLcharacters;

		Descs.RemoveAll();
		TuneIns.RemoveAll();
		Bitrates.RemoveAll();
		Metaflags.RemoveAll();
		m_cListCtrl.DeleteAllItems();

		doc = htmlSAXParseDoc((xmlChar *)pgResult.memory,NULL,SAXHandler,(void *)NULL);

        if (doc) {
           xmlFreeDoc(doc);
           doc = 0;
        }
		curl_easy_cleanup(curl);


		int count = 0;
		for (int i=0;i<Descs.GetSize();i++) {
			if ((i < Descs.GetSize()) && (i < Bitrates.GetSize()) && (i< Metaflags.GetSize())) {
					lvi.mask =  LVIF_IMAGE | LVIF_TEXT;
					// strItem.Format(_T("Item %i"), i);
					lvi.iItem = count;
					lvi.iSubItem = 0;
					if ((LPTSTR)(LPCTSTR)Descs.GetAt(i)) {
						lvi.pszText = (LPTSTR)(LPCTSTR)Descs.GetAt(i);
					}
					else {
						lvi.pszText = "";
					}
					m_cListCtrl.InsertItem(&lvi);

					lvi.iSubItem = 1;
					if ((LPTSTR)(LPCTSTR)Bitrates.GetAt(i)) {
						lvi.pszText = (LPTSTR)(LPCTSTR)Bitrates.GetAt(i);
					}
					else {
						lvi.pszText = "";
					}

					m_cListCtrl.SetItem(&lvi);

					lvi.iSubItem = 2;
					if ((LPTSTR)(LPCTSTR)Metaflags.GetAt(i)) {
						lvi.pszText = (LPTSTR)(LPCTSTR)Metaflags.GetAt(i);
					}
					else {
						lvi.pszText = "";
					}
					m_cListCtrl.SetItem(&lvi);
					count++;
			}
		}
	UpdateData(FALSE);
	EndWaitCursor();
}

void CSRipperDlg::OnRefresh() 
{
	DoSearch(GENRE_SEARCH);
}

void CSRipperDlg::OnStopripping() 
{
	if (bConnecting) {
		MessageBox("Currently trying to connect...be patient, it will time out after 15 seconds...", NULL, MB_OK);
		return;
	}
	// TODO: Add your control notification handler code here
	if (bRipping) {
		rip_manager_stop();
	}
	m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "");
	m_CurrentDialog->SetDlgItemText(IDC_SONGTITLE, "");
	m_CurrentDialog->SetDlgItemText(IDC_BYTES, "");

	m_CurrentDialog->m_StopRipping.EnableWindow(FALSE);
	m_CurrentDialog->m_Ripaway.EnableWindow(TRUE);
	m_CurrentDialog->m_Genre.EnableWindow(TRUE);
	m_CurrentDialog->m_Refresh.EnableWindow(TRUE);
	m_CurrentDialog->m_Destinationctrl.EnableWindow(TRUE);
	m_CurrentDialog->m_URLctrl.EnableWindow(TRUE);
	m_CurrentDialog->m_OKctrl.EnableWindow(TRUE);
	m_CurrentDialog->m_Folder.EnableWindow(TRUE);
	m_CurrentDialog->m_MaxBytesCtl.EnableWindow(TRUE);
	m_CurrentDialog->m_ConnectRelay.EnableWindow(FALSE);
	m_CurrentDialog->m_RelayPortCtrl.EnableWindow(TRUE);
	bRipping = false;
/*
	if (pGenM3u) {
		fclose(pGenM3u);
		pGenM3u = 0;
	}
	*/
}

void CSRipperDlg::OnOK() 
{
	// TODO: Add extra validation here

	if (bRipping) {
		bRipping = false;
		OnStopripping();
	}

	UpdateData(TRUE);
	WritePrivateProfileString("SRipper","OutputDir",m_Destination, "sripper.ini");
	WritePrivateProfileString("SRipper","lastURL", m_URL, "sripper.ini");
	WritePrivateProfileString("SRipper","UserAgent", m_OptionDialog.m_UserAgent, "sripper.ini");
	char relayPort[255] = "";
	sprintf(relayPort, "%d", m_RelayPort);
	WritePrivateProfileString("SRipper","relayPort", relayPort, "sripper.ini");

	if (m_OptionDialog.m_AddId3) {
		WritePrivateProfileString("SRipper","addID3", "TRUE", "sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","addID3", "FALSE", "sripper.ini");
	}
	if (m_OptionDialog.m_CreateM3U) {
		WritePrivateProfileString("SRipper","genM3U", "TRUE", "sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","genM3U", "FALSE", "sripper.ini");
	}

	if (m_OptionDialog.m_AddSeq) {
		WritePrivateProfileString("SRipper","addSeqNumber", "TRUE","sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","addSeqNumber", "FALSE","sripper.ini");
	}
	if (m_OptionDialog.m_Overwrite) {
		WritePrivateProfileString("SRipper","Overwrite", "TRUE", "sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","Overwrite", "FALSE", "sripper.ini");
	}
	if (m_PatternEnable) {
		WritePrivateProfileString("SRipper","PatternEnable", "TRUE", "sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","PatternEnable", "FALSE", "sripper.ini");
	}
	if (m_OptionDialog.m_IconAnim) {
		WritePrivateProfileString("SRipper","IconAnim", "TRUE", "sripper.ini");
	}
	else {
		WritePrivateProfileString("SRipper","IconAnim", "FALSE", "sripper.ini");
	}

	if (m_pTray) {
		delete m_pTray ;
		m_pTray = NULL ;
	} 

	CResizableDialog::OnOK();
}


void CSRipperDlg::OnUpdateBytes() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here

//	UpdateData(FALSE);
}

void CSRipperDlg::OnUpdateSongtitle() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
}


void CSRipperDlg::OnUpdateDestination() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	

	UpdateData(TRUE);
}



void CSRipperDlg::OnFolder() 
{
	// TODO: Add your control notification handler code here
	CFolderDialog	folderdialog;

	if (folderdialog.DoModal() == IDOK) {
		m_Destination = folderdialog.GetPathName() + "\\";
		UpdateData(FALSE);
	}
}


void CSRipperDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
		// TODO: Add your message handler code here
//	CMenu menu;

//	menu.LoadMenu(IDR_MENU1);
//	CMenu *pContextMenu = menu.GetSubMenu(0);

//	pContextMenu->TrackPopupMenu(TPM_LEFTALIGN |
//		TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
//		point.x, point.y, AfxGetMainWnd());
}

void CSRipperDlg::OnDblclkListCtrl(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	

	if (gIsRipping) {
		MessageBox("Cannot select while ripping..", "Error", MB_OK);
	}
	else {
		int selected = m_cListCtrl.GetSelectionMark();

		CString	ip;
		CString	tunein;
		CString desc;

		CArray<CString, CString>	ClusterEntries;
		CArray<CString, CString>	ClusterEntryDescs;
		char	*result;

		UpdateData(TRUE);
		tunein = TuneIns.GetAt(selected);
		desc = Descs.GetAt(selected);

		m_StreamName = desc;
		UpdateData(FALSE);

		ClusterEntries.RemoveAll();
		ClusterEntryDescs.RemoveAll();

        CURL *curl = NULL;


        if (pgResult.memory) {
                free(pgResult.memory);
        }
        pgResult.memory = NULL;
        pgResult.size = 0;
        curl = curl_easy_init();

        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, URLCallback);
        curl_easy_setopt(curl, CURLOPT_FILE, (void *)&(pgResult));
		curl_easy_setopt(curl, CURLOPT_URL, tunein);

		int res = curl_easy_perform(curl);
	
		curl_easy_cleanup(curl);
		
		result = pgResult.memory;

		char *p1 = 0;
		p1 = strstr(result, "[playlist]");
		if (p1 == NULL) {
			MessageBox("Could not retrieve cluster information", "Error", MB_OK);
			return;
		}
		else {
			char	*p2;
			char	strnumentries[25] = "";
			int		numentries = 0;
			p2 = strstr(p1, "numberofentries=");
			if (p2 != NULL) {
				p2 = p2 + strlen("numberofentries=");
				char	*p3;
				p3 = strstr(p2, "\n");
				if (p3 != NULL) {
					memset(strnumentries, '\000', sizeof(strnumentries));
					strncpy(strnumentries, p2, p3-p2);
					numentries = atoi(strnumentries);
				}
				CMirrorSelect	mirrorDialog;

				for (int i=1;i<=numentries;i++) {
					char	*p4;
					char	*p5;
					char	Tag[25] = "";
					char	IP[35] = "";
					char	Desc[255] = "";
					memset(IP, '\000', sizeof(IP));
					memset(Desc, '\000', sizeof(Desc));
					sprintf(Tag, "File%d", i);
					p4 = strstr(p3, Tag);
					if (p4 != NULL) {
						p4 = p4 + strlen(Tag) + 1 + strlen("http://");
						p5 = strstr(p4, "\n");
						if (p5 != NULL) {
							strncpy(IP, p4, p5-p4);
						}
					}
					sprintf(Tag, "Title%d", i);
					p4 = strstr(p3, Tag);
					if (p4 != NULL) {
						p4 = p4 + strlen(Tag) + 1;
						p5 = strstr(p4, "\n");
						if (p5 != NULL) {
							strncpy(Desc, p4, p5-p4);
						}
					}
					mirrorDialog.m_ClusterEntries.Add(IP);
					mirrorDialog.m_ClusterEntryDescs.Add(Desc);
				}


				mirrorDialog.m_Selected = -1;
				mirrorDialog.DoModal();
			
				if (mirrorDialog.m_Selected != -1) {
					ip = mirrorDialog.m_ClusterEntries.GetAt(mirrorDialog.m_Selected);
				}
			}
		}
		p1 = 0;
		char	theip[255] = "";
		char	theport[25] = "";
		p1 = strchr(ip, ':');
		memset(theip, '\000', sizeof(theip));
		memset(theport, '\000', sizeof(theport));

		if (p1 != NULL) {
			strncpy(theip, ip, p1 - ip);
			strcpy(theport, p1 + 1);
			CString m_IP = theip;
			int m_Port = atoi(theport);
			char	bleh[255] = "";
			sprintf(bleh, "http://%s:%d", m_IP, m_Port);
			m_URL = bleh;
			UpdateData(FALSE);
		}
	}
	*pResult = 0;
}

void CSRipperDlg::OnConnectRelay() 
{
	if (m_RelayPort == 0) {
		MessageBox("Relay port cannot be zero if you want to use this feature", "Error", MB_OK);
		return;
	}
	// TODO: Add your control notification handler code here
	HWND hwndWinamp = ::FindWindow("Winamp v1.x",NULL); 

	FILE	*filep = fopen("relay.m3u", "w");
	if (filep) {
		fprintf(filep, "http://127.0.0.1:%d\n", m_RelayPort);
		fclose(filep);
		ShellExecute(NULL, "open", "relay.m3u", NULL, NULL, SW_SHOWNORMAL);
	}
	else {
		if (hwndWinamp != NULL) {
			::SendMessage(hwndWinamp,WM_WA_IPC,0,IPC_DELETE);
			COPYDATASTRUCT cds;
			cds.dwData = IPC_PLAYFILE;
			char	url[255] = "";
			sprintf(url, "http://127.0.0.1:%d", m_RelayPort);
			cds.lpData = (void *) url;
			cds.cbData = strlen((char *) cds.lpData)+1; // include space for null char
			::SendMessage(hwndWinamp, WM_COPYDATA,(WPARAM)NULL,(LPARAM)&cds);
			::SendMessage(hwndWinamp, WM_WA_IPC,0,IPC_STARTPLAY);
		}
		else {
			MessageBox("Winamp must be running if you want to use this feature", "Error", MB_OK);
		}
	}

}

void CSRipperDlg::OnColumnclickListCtrl(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	int column = pNMListView->iSubItem;

	if (column == 0) {
		SortbyDesc();
	}
	if (column == 1) {
		SortbyBitrate();
	}

	*pResult = 0;
}

bool descflop = true;
void CSRipperDlg::SortbyDesc()
{

	sortedDescs.RemoveAll();
	sortedTuneIns.RemoveAll();
	sortedBitrates.RemoveAll();
	sortedMetaflags.RemoveAll();

	int index = 0;
	for(int i=0;i<Descs.GetSize();i++) {
		bool added = false;
		int j = 0;
		for (j=0;j<sortedDescs.GetSize();j++) {
			CString desc1 = Descs.GetAt(i);
			CString desc2 = sortedDescs.GetAt(j);

			if (descflop) {
				if (Descs.GetAt(i) < sortedDescs.GetAt(j)) {
					break;
				}
			}
			else {
				if (Descs.GetAt(i) > sortedDescs.GetAt(j)) {
					break;
				}
			}
		}
		index = j;
		sortedDescs.InsertAt(index, Descs.GetAt(i));
		sortedTuneIns.InsertAt(index, TuneIns.GetAt(i));
		sortedBitrates.InsertAt(index, Bitrates.GetAt(i));
		sortedMetaflags.InsertAt(index, Metaflags.GetAt(i));


	}

	Descs.RemoveAll();
	TuneIns.RemoveAll();
	Bitrates.RemoveAll();
	Metaflags.RemoveAll();

	for(i=0;i<sortedDescs.GetSize();i++) {
		Descs.SetAtGrow(i, sortedDescs.GetAt(i));
		TuneIns.SetAtGrow(i, sortedTuneIns.GetAt(i));
		Bitrates.SetAtGrow(i, sortedBitrates.GetAt(i));
		Metaflags.SetAtGrow(i, sortedMetaflags.GetAt(i));
	}

	if (descflop) {
		descflop = false;
	}
	else {
		descflop = true;
	}
	ReloadListbox();
}

void CSRipperDlg::ReloadListbox()
{
	LVITEM	lvi;

	m_cListCtrl.DeleteAllItems();

	for(int i=0;i<Descs.GetSize();i++) {
		lvi.mask =  LVIF_IMAGE | LVIF_TEXT;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = (LPTSTR)(LPCTSTR)(Descs.GetAt(i));
		m_cListCtrl.InsertItem(&lvi);

		lvi.iSubItem = 1;
		lvi.pszText = (LPTSTR)(LPCTSTR)(Bitrates.GetAt(i));
		m_cListCtrl.SetItem(&lvi);

		lvi.iSubItem = 2;
		lvi.pszText = (LPTSTR)(LPCTSTR)Metaflags.GetAt(i);
		m_cListCtrl.SetItem(&lvi);

	}

}

bool bitrateflop = false;

void CSRipperDlg::SortbyBitrate()
{
	sortedDescs.RemoveAll();
	sortedTuneIns.RemoveAll();
	sortedBitrates.RemoveAll();
	sortedMetaflags.RemoveAll();

	int index = 0;
	for(int i=0;i<Bitrates.GetSize();i++) {
		bool added = false;
		int j = 0;
		for (j=0;j<sortedBitrates.GetSize();j++) {
			CString bit1 = Bitrates.GetAt(i);
			CString bit2 = sortedBitrates.GetAt(j);

			bit1.Replace("kbps", "");
			bit2.Replace("kbps", "");
			int	ibit1 = atoi(LPCSTR(bit1));
			int	ibit2 = atoi(LPCSTR(bit2));

			if (bitrateflop) {
				if (ibit1 < ibit2) {
					break;
				}
			}
			else {
				if (ibit1 > ibit2) {
					break;
				}
			}
		}
		index = j;
		sortedDescs.InsertAt(index, Descs.GetAt(i));
		sortedTuneIns.InsertAt(index, TuneIns.GetAt(i));
		sortedBitrates.InsertAt(index, Bitrates.GetAt(i));
		sortedMetaflags.InsertAt(index, Metaflags.GetAt(i));


	}

	Descs.RemoveAll();
	TuneIns.RemoveAll();
	Bitrates.RemoveAll();
	Metaflags.RemoveAll();

	for(i=0;i<sortedBitrates.GetSize();i++) {
		Descs.SetAtGrow(i, sortedDescs.GetAt(i));
		TuneIns.SetAtGrow(i, sortedTuneIns.GetAt(i));
		Bitrates.SetAtGrow(i, sortedBitrates.GetAt(i));
		Metaflags.SetAtGrow(i, sortedMetaflags.GetAt(i));
	}

	if (bitrateflop) {
		bitrateflop = false;
	}
	else {
		bitrateflop = true;
	}
	ReloadListbox();

}


void CSRipperDlg::StopRipping()
{
//		bRipping = true;
		OnStopripping();
}

VOID CALLBACK TimerProc(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime) {
 
	// TODO: Add your message handler code here and/or call default
	if (StopTheRipping) {
		m_CurrentDialog->StopRipping();
		StopTheRipping = 0;
	}
}

void CSRipperDlg::OnAddpattern() 
{
	CString	songPattern;
	CString stationPattern;
	patternDialog.m_StationPattern = m_StreamName;
	patternDialog.m_SongPattern = m_curinfo.filename;
	// TODO: Add your control notification handler code here
	if (patternDialog.DoModal() == IDOK) {
		songPattern = "";
		stationPattern = "";

		songPattern = patternDialog.m_SongPattern;
		stationPattern = patternDialog.m_StationPattern;
		if ((songPattern != "") && (stationPattern != "")) {
			SongPatterns.Add(songPattern);
			StationPatterns.Add(stationPattern);
			LVITEM lvi;

			lvi.mask =  LVIF_IMAGE | LVIF_TEXT;
			// strItem.Format(_T("Item %i"), i);
			lvi.iItem = SongPatterns.GetUpperBound();
			lvi.iSubItem = 0;
			lvi.pszText = (LPTSTR)(LPCTSTR)(StationPatterns.GetAt(SongPatterns.GetUpperBound()));
			m_PatternMatch.InsertItem(&lvi);

			lvi.iSubItem = 1;
			lvi.pszText = (LPTSTR)(LPCTSTR)(SongPatterns.GetAt(SongPatterns.GetUpperBound()));
			m_PatternMatch.SetItem(&lvi);



		}
	}
	WritePatterns();

}

void CSRipperDlg::OnDeletepattern() 
{
	// TODO: Add your control notification handler code here

	POSITION pos;
	int loop = 1;
	while (loop) {
		pos = m_PatternMatch.GetFirstSelectedItemPosition();
		if (pos != NULL) {
			int nItem = m_PatternMatch.GetNextSelectedItem(pos);
			m_PatternMatch.DeleteItem(nItem);
			SongPatterns.RemoveAt(nItem);
			StationPatterns.RemoveAt(nItem);
		}
		else {
			loop = 0;
		}
	}

	WritePatterns();

}

void CSRipperDlg::WritePatterns()
{
	char buf[255] = "";
	char	stationPattern[255] = "";
	char	songPattern[255] = "";


	int i = 0;
	for (i = 0; i < StationPatterns.GetSize();i++) {
		memset(buf, '\000', sizeof(buf));
		memset(stationPattern, '\000', sizeof(stationPattern));
		memset(songPattern, '\000', sizeof(songPattern));

		strcpy(stationPattern, LPCSTR(StationPatterns.GetAt(i)));
		strcpy(songPattern, LPCSTR(SongPatterns.GetAt(i)));

		sprintf(buf, "StationPattern%d", i);
		WritePrivateProfileString("SRipper",buf, stationPattern, "sripper.ini");
		sprintf(buf, "SongPattern%d", i);
		WritePrivateProfileString("SRipper",buf, songPattern, "sripper.ini");

	}
	memset(buf, '\000', sizeof(buf));
	memset(stationPattern, '\000', sizeof(stationPattern));
	memset(songPattern, '\000', sizeof(songPattern));

	strcpy(stationPattern, "EndOfStations");
	strcpy(songPattern, "EndOfSongs");

	sprintf(buf, "StationPattern%d", i);
	WritePrivateProfileString("SRipper",buf, stationPattern, "sripper.ini");
	sprintf(buf, "SongPattern%d", i);
	WritePrivateProfileString("SRipper",buf, songPattern, "sripper.ini");
}

void CSRipperDlg::OnPatternEnable() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);

	if (m_PatternEnable) {
		; //writeFileFlag = 0;
	}
	else {
		writeFileFlag = 1;
	}
}

int CSRipperDlg::CheckIncludedTrack(char *track)
{

	CString StreamName;
	CString TrackName;
	int i = 0; 
	int	match = 0;
	int matchnumber = 0;
	

	TrackName = track;
	StreamName = m_curinfo.streamname;
	if (m_PatternEnable) {
		for (i = 0; i < StationPatterns.GetSize();i++) {

			CString bleh = StationPatterns.GetAt(i);
			CString bleh2 = SongPatterns.GetAt(i);

			if ((StreamName.Find(LPCSTR(StationPatterns.GetAt(i))) > -1) || (StationPatterns.GetAt(i) == "any_match")) {
				if ((TrackName.Find(LPCSTR(SongPatterns.GetAt(i))) > -1) || (SongPatterns.GetAt(i) == "any_match")) {
					match = 1;
					matchnumber = i;
				}
			}
		}
		if (match) {
			writeFileFlag = 1;
			m_CurrentDialog->SetDlgItemText(IDC_RIPPING, "Ripping Matched Track");

//			m_PatternMatch.SetCurSel(i);
		}
		else {
			writeFileFlag = 0;
		}
	}
	return 1;
}

void CSRipperDlg::OnHide() 
{
	// TODO: Add your control notification handler code here
	// Load icon onto taskbar tray
	m_pTray = new CTrayNot (this,WM_TRAY_NOTIFY, NULL,theApp.m_pIconList);
	m_pTray->SetState(0);
	m_bHidden = TRUE;

}
void CSRipperDlg::OnUnHide()
{
	ShowWindow (SW_RESTORE) ;
	m_bHidden = FALSE ;
	/////////////////////////////////////
	// Remove icon from taskbar tray
	if (m_pTray) {
		delete m_pTray ;
		m_pTray = NULL ;
	}
}
LONG CSRipperDlg::OnTrayNotify ( WPARAM wParam, LPARAM lParam )
{
	switch (lParam) {
	case WM_RBUTTONDOWN:
			{
			CMenu menu ;
			// Load and Verify Menu
			VERIFY(menu.LoadMenu(IDR_TRAY));
			CMenu* pPopup = menu.GetSubMenu (0) ;
			ASSERT(pPopup != NULL);

			// Get the cursor position
			POINT pt ;
			GetCursorPos (&pt) ;

			// Fix Microsofts' BUG!!!!
			SetForegroundWindow();

			///////////////////////////////////
			// Display The Menu
			pPopup->TrackPopupMenu(TPM_LEFTALIGN |
			TPM_RIGHTBUTTON,pt.x, pt.y, AfxGetMainWnd());
			break ;
			}
	case WM_LBUTTONDBLCLK:
	//////////////////////////////////
	// Unhide our Window
		if (m_bHidden) {
			ShowWindow (SW_RESTORE);
		}
	//OnUnHide() ;
		break ;
	}

	return (0) ;
}
void CSRipperDlg::OnDestroy() 
{
	CDialog::OnDestroy();

// Remove Icon from Tray
	if (m_pTray) {
		delete m_pTray ;
		m_pTray = NULL ;
	} 
}

void CSRipperDlg::OnTrayRestore() 
{
// UnHide Application
	if (m_bHidden) {
		ShowWindow (SW_RESTORE);
	}
	m_bHidden = FALSE ;
}

void CSRipperDlg::OnHideapp() 
{
//This will be the onclick for the hide button
//in order to call that the app is minimised.
	OnHide();
	theApp.HideApplication();
} 

void CSRipperDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	if (bRipping) {
		//bRipping = false;
		OnStopripping();
	}
	if (m_pTray) {
		delete m_pTray ;
		m_pTray = NULL ;
	} 
	OnOK();

	CResizableDialog::OnClose();
}

void CSRipperDlg::OnSearch() 
{
	// TODO: Add your control notification handler code here
	DoSearch(TEXT_SEARCH);
	
}

void CSRipperDlg::OnMoreoptions() 
{
	// TODO: Add your control notification handler code here
	m_OptionDialog.DoModal();
}

void CSRipperDlg::OnSir() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(NULL, "open", "http://www.saveinternetradio.org", NULL, NULL, SW_SHOWNORMAL);
}
